function Fano() {
};
  
Fano.prototype = {

    init: function(canvas) {
        this.ctx = canvas.getContext('2d');
        this.height = canvas.height;
        this.width = canvas.width;
        this.delta = Math.min(this.width-12, this.height-12);
        this.r = 0.10;
        var a = Math.cos(Math.PI/3);
        var b = Math.sin(Math.PI/3);
        this.p = [[-b,-a], [b,-a], [0,1], [0,-a], [b/2,(1-a)/2], [-b/2,(1-a)/2], [0,0]];
        this.cir = a;
        this.step = 0;
        this.angle = 0;
        this.alpha = 3;
        },

    draw: function () {
        this.ctx.save();
        this.ctx.translate(this.width/2, this.height/2);
        this.ctx.scale(this.delta/2, -this.delta/2);
        this.ctx.clearRect(-2,-2,4,4);
        this.ctx.rotate(Math.PI*this.step/180);
        this.ctx.lineWidth = 0.04;
        this.ctx.beginPath();
        this.ctx.moveTo(this.p[0][0], this.p[0][1]);
        this.ctx.lineTo(this.p[1][0], this.p[1][1]);
        this.ctx.lineTo(this.p[2][0], this.p[2][1]);
        this.ctx.closePath();
        this.ctx.stroke();
        this.ctx.beginPath();
        this.ctx.arc(0, 0, this.cir, 0, 2*Math.PI, true);
        this.ctx.stroke();
        this.ctx.beginPath();
        this.ctx.lineTo(this.p[0][0], this.p[0][1]);
        this.ctx.lineTo(this.p[4][0], this.p[4][1]);
        this.ctx.moveTo(this.p[1][0], this.p[1][1]);
        this.ctx.lineTo(this.p[5][0], this.p[5][1]);
        this.ctx.moveTo(this.p[3][0], this.p[3][1]);
        this.ctx.lineTo(this.p[2][0], this.p[2][1]);
        this.ctx.stroke();
        this.ctx.fillStyle = "rgba(171, 33, 58, 255)";
        this.ctx.lineWidth = 0.01;
        for (var i = 0; i < 7; i++) {
          this.ctx.beginPath();
          this.ctx.arc(this.p[i][0], this.p[i][1], this.r, 0, 2*Math.PI, true);
          this.ctx.fill();
          this.ctx.stroke();
        };
        this.ctx.restore();
    },

    twist: function () {
        var self = this;
        if (self.intervalID) return;
        self.step = 0;
        self.intervalID = setInterval(function () { 
            self.angle += 1;
            if (self.angle > 360) {
              self.angle -= 360;
            }
            self.draw();
            self.step += 1;
            if (self.step > 120) {
              clearInterval(self.intervalID);
              self.intervalID = null;
            }
          }, 7);
   }
};

$(document).ready(function () {
    var canvas = document.getElementById('fano');
    if (canvas.getContext) {
      var fano = new Fano();
      fano.init(canvas);
      fano.draw();
      $(canvas).hover(function () { fano.twist(); });
      $(canvas).click(function () { fano.twist(); });
    }
  });
