(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      9024,        243]
NotebookOptionsPosition[      8342,        217]
NotebookOutlinePosition[      8832,        234]
CellTagsIndexPosition[      8789,        231]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"ColorData", "[", "38", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"ColorDataFunction", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "8", ",", "1"}], "}"}], ",", 
  PanelBox[
   StyleBox[
    GraphicsBox[{
      {RGBColor[0.5686274509803921, 0.2980392156862745, 0.1450980392156863], 
       EdgeForm[Opacity[0.1]], 
       RectangleBox[{1, 0}, Offset[{-1, -1}, {2, 1}]]}, 
      {RGBColor[0.7058823529411765, 0.6980392156862745, 0.4980392156862745], 
       EdgeForm[Opacity[0.1]], 
       RectangleBox[{2, 0}, Offset[{-1, -1}, {3, 1}]]}, 
      {RGBColor[0.6509803921568628, 0.7607843137254902, 0.22745098039215686`],
        EdgeForm[Opacity[0.1]], 
       RectangleBox[{3, 0}, Offset[{-1, -1}, {4, 1}]]}, 
      {RGBColor[0.39215686274509803`, 0.7294117647058823, 0.5843137254901961],
        EdgeForm[Opacity[0.1]], 
       RectangleBox[{4, 0}, Offset[{-1, -1}, {5, 1}]]}, 
      {RGBColor[0.8235294117647058, 0.8941176470588236, 0.9490196078431372], 
       EdgeForm[Opacity[0.1]], 
       RectangleBox[{5, 0}, Offset[{-1, -1}, {6, 1}]]}, 
      {RGBColor[0.22745098039215686`, 0.19215686274509805`, 0.4], EdgeForm[
       Opacity[0.1]], RectangleBox[{6, 0}, Offset[{-1, -1}, {7, 1}]]}, 
      {RGBColor[0.5019607843137255, 0.23921568627450981`, 0.4470588235294118],
        EdgeForm[Opacity[0.1]], 
       RectangleBox[{7, 0}, Offset[{-1, -1}, {8, 1}]]}, 
      {RGBColor[
       0.6705882352941176, 0.12941176470588237`, 0.22745098039215686`], 
       EdgeForm[Opacity[0.1]], 
       RectangleBox[{8, 0}, Offset[{-1, -1}, {9, 1}]]}},
     AspectRatio->NCache[
       Rational[1, 10], 0.1],
     ImageSize->65,
     PlotRangePadding->None],
    StripOnInput->False,
    CacheGraphics->False],
   FrameMargins->5], "]"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"g", " ", "=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"e", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{"0", ",", " ", 
         RowBox[{"{", "7", "}"}]}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"e", "\[LeftDoubleBracket]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "2", ",", "3"}], "}"}], "\[RightDoubleBracket]"}], 
       " ", "=", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"1", "/", "2"}], ",", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"60", "Degree"}], "]"}]}], "}"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"e", "\[LeftDoubleBracket]", 
        RowBox[{"{", 
         RowBox[{"4", ",", "5", ",", "6"}], "}"}], "\[RightDoubleBracket]"}], 
       " ", "=", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"Mean", "[", 
          RowBox[{"e", "\[LeftDoubleBracket]", "#", "\[RightDoubleBracket]"}],
           "]"}], "&"}], " ", "/@", " ", 
        RowBox[{"Subsets", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", " ", 
          RowBox[{"{", "2", "}"}]}], "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"e", "\[LeftDoubleBracket]", "7", "\[RightDoubleBracket]"}], 
       "  ", "=", " ", 
       RowBox[{"Mean", "[", 
        RowBox[{"e", "\[LeftDoubleBracket]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "3"}], "}"}], "\[RightDoubleBracket]"}],
         "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"r", " ", "=", " ", "0.055"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Thickness", "[", "0.01", "]"}], ",", " ", 
           "\[IndentingNewLine]", 
           RowBox[{"Line", "[", 
            RowBox[{"e", "\[LeftDoubleBracket]", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", "3", ",", "1"}], "}"}], 
             "\[RightDoubleBracket]"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"e", "\[LeftDoubleBracket]", 
               RowBox[{"{", 
                RowBox[{"1", ",", " ", "6"}], "}"}], 
               "\[RightDoubleBracket]"}], ",", " ", 
              RowBox[{"e", "\[LeftDoubleBracket]", 
               RowBox[{"{", 
                RowBox[{"2", ",", " ", "5"}], "}"}], 
               "\[RightDoubleBracket]"}], ",", " ", 
              RowBox[{"e", "\[LeftDoubleBracket]", 
               RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[RightDoubleBracket]"}]}], 
             "}"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Circle", "[", 
            RowBox[{
             RowBox[{
             "e", "\[LeftDoubleBracket]", "7", "\[RightDoubleBracket]"}], ",",
              " ", 
             RowBox[{"0.95", " ", 
              RowBox[{
               RowBox[{"Tan", "[", 
                RowBox[{"30", "Degree"}], "]"}], "/", "2"}]}]}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"EdgeForm", "[", "Black", "]"}], ",", 
           RowBox[{"FaceForm", "[", 
            RowBox[{"ColorData", "[", 
             RowBox[{"38", ",", " ", "8"}], "]"}], "]"}], ",", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"Disk", "[", 
              RowBox[{"#", ",", " ", "r"}], "]"}], "&"}], " ", "/@", " ", 
            "e"}]}], "}"}]}], "\[IndentingNewLine]", "}"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"g", ",", " ", 
   RowBox[{"ImageSize", " ", "\[Rule]", " ", "Small"}]}], "]"}]}], "Input"],

Cell[BoxData[
 GraphicsBox[{
   {Thickness[0.01], 
    LineBox[NCache[{{0, 0}, {1, 0}, {
       Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {0, 0}}, {{0, 0}, {1,
        0}, {0.5, 0.8660254037844386}, {0, 0}}]], 
    LineBox[NCache[{{{0, 0}, {
        Rational[3, 4], Rational[1, 4] 3^Rational[1, 2]}}, {{1, 0}, {
        Rational[1, 4], Rational[1, 4] 3^Rational[1, 2]}}, {{
        Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], 0}}}, {{{0, 0}, {0.75, 0.4330127018922193}}, {{1, 
        0}, {0.25, 0.4330127018922193}}, {{0.5, 0.8660254037844386}, {
        0.5, 0}}}]], 
    CircleBox[
     NCache[{Rational[1, 2], Rational[1, 2] 3^Rational[-1, 2]}, {0.5, 
      0.2886751345948129}], 0.27424137786507224`]}, 
   {EdgeForm[GrayLevel[0]], FaceForm[RGBColor[
    0.6705882352941176, 0.12941176470588237`, 0.22745098039215686`]], 
    DiskBox[{0, 0}, 0.055], DiskBox[{1, 0}, 0.055], 
    DiskBox[NCache[{Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {0.5, 
      0.8660254037844386}], 0.055], 
    DiskBox[NCache[{Rational[1, 2], 0}, {0.5, 0}], 0.055], 
    DiskBox[NCache[{Rational[1, 4], Rational[1, 4] 3^Rational[1, 2]}, {0.25, 
      0.4330127018922193}], 0.055], 
    DiskBox[NCache[{Rational[3, 4], Rational[1, 4] 3^Rational[1, 2]}, {0.75, 
      0.4330127018922193}], 0.055], 
    DiskBox[NCache[{Rational[1, 2], Rational[1, 2] 3^Rational[-1, 2]}, {0.5, 
      0.2886751345948129}], 0.055]}},
  ImageSize->Small]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\</home/mariano/public_html/Lineal/images/fano.png\>\"", ",", " ", "g", 
   ",", " ", 
   RowBox[{"ImageSize", " ", "\[Rule]", " ", "100"}]}], "]"}]], "Input"],

Cell[BoxData["\<\"/home/mariano/public_html/Lineal/images/fano.png\"\>"], \
"Output"]
}, Open  ]]
},
WindowSize->{971, 668},
WindowMargins->{{Automatic, 112}, {Automatic, 15}},
FrontEndVersion->"8.0 for Linux x86 (32-bit) (November 7, 2010)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "mariano", 
   ".Mathematica", "SystemFiles", "FrontEnd", "StyleSheets"}, "MyDefault.nb", 
  CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 63, 1, 44, "Input"],
Cell[645, 25, 1691, 37, 76, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2373, 67, 4140, 104, 465, "Input"],
Cell[6516, 173, 1471, 28, 280, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8024, 206, 214, 5, 73, "Input"],
Cell[8241, 213, 85, 1, 64, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

